#
# Don't change this file. It was autogenerated by 'spec.make.sh'
#
%define my_version 1.5.0
%define my_release 1

Name:          statifier
Version:       %{my_version}
Release:       %{my_release}
License:       GPL
Group:         Development/Tools
Summary:       Convert elf dynamic linked exe to "pseudo-static"
Packager:      Valery Reznic <valery_reznic@users.sourceforge.net>
Source:	       %{name}-%{version}.tar.gz
Url:           http://%{name}.sourceforge.net	

ExclusiveOs:   Linux

ExclusiveArch: %{ix86}
ExclusiveArch: x86_64
ExclusiveArch: alpha

Requires:      binutils
Requires:      fileutils
Requires:      gawk
Requires:      gdb >= 5.2
Requires:      sed
Requires:      sh-utils
Requires:      textutils

BuildRoot:     %{_builddir}/%{buildsubdir}-install-root

%ifarch %{ix86}
   %define has_elf_32 1
   %define has_elf_64 0
%endif

%ifarch x86_64
   %define has_elf_32 1
   %define has_elf_64 1
%endif

%ifarch alpha
   %define has_elf_32 0
   %define has_elf_64 1
%endif

%description
Statifier create from dynamically linked ELF executable
and all it's libraries (and all LD_PRELOAD libraries if any)
one file. This file can be copied and run on another machine
without need to drag all it's libraries.

%prep
%setup

%build
make all

%install
if [ "$RPM_BUILD_ROOT" != "/" ]; then
   rm -rf "$RPM_BUILD_ROOT"
else
   :
fi
make install DESTDIR="$RPM_BUILD_ROOT" MANPAGE_SUFFIX=.gz

%clean
if [ "$RPM_BUILD_ROOT" != "/" ]; then
   rm -rf "$RPM_BUILD_ROOT"
else
   :
fi

%files
%defattr(-,root,root)

# Other files
%dir /usr/lib/statifier
     /usr/lib/statifier/VERSION
     /usr/lib/statifier/statifier.sh
     /usr/lib/statifier/statifier_parser.src

     /usr/bin/statifier

%doc %{_mandir}/man1/statifier.1*

%doc AUTHORS
%doc ChangeLog
%doc FAQ
%doc INSTALL
%doc LICENSE
%doc NEWS
%doc README
%doc THANKS
%doc TODO

%doc doc

# Common files for elf32 and elf64
     /usr/lib/statifier/statifier_lib.src
     /usr/lib/statifier/statifier_common.sh
     /usr/lib/statifier/statifier_loader.sh
     /usr/lib/statifier/statifier_dump.sh
     /usr/lib/statifier/statifier_create_starter.sh
     /usr/lib/statifier/statifier_create_exe.sh
     /usr/lib/statifier/dumps.sh
     /usr/lib/statifier/regs.sh
     /usr/lib/statifier/set_thread_area.sh
     /usr/lib/statifier/split.sh
     /usr/lib/statifier/statifier.gdb

%if %{has_elf_32}
# Elf32	own files
%dir /usr/lib/statifier/32
     /usr/lib/statifier/32/copy_ehdr
     /usr/lib/statifier/32/dl-var
     /usr/lib/statifier/32/elfinfo
     /usr/lib/statifier/32/elf_find_pattern
     /usr/lib/statifier/32/elf_stripped
     /usr/lib/statifier/32/find_dl_argc
     /usr/lib/statifier/32/find_dl_argv
     /usr/lib/statifier/32/find_dl_auxv
     /usr/lib/statifier/32/find_dl_platform
     /usr/lib/statifier/32/find_environ
     /usr/lib/statifier/32/loader_base_test
     /usr/lib/statifier/32/phdrs
     /usr/lib/statifier/32/regs
     /usr/lib/statifier/32/set_thread_area_addr
     /usr/lib/statifier/32/set_thread_area
     /usr/lib/statifier/32/strtoul
     /usr/lib/statifier/32/tls_test
     /usr/lib/statifier/32/properties.src
     /usr/lib/statifier/32/regs.awk
     /usr/lib/statifier/32/set_thread_area.gdb
# Elf32	links
     /usr/lib/statifier/32/statifier_lib.src
     /usr/lib/statifier/32/statifier_common.sh
     /usr/lib/statifier/32/statifier_loader.sh
     /usr/lib/statifier/32/statifier_dump.sh
     /usr/lib/statifier/32/statifier_create_starter.sh
     /usr/lib/statifier/32/statifier_create_exe.sh
     /usr/lib/statifier/32/dumps.sh
     /usr/lib/statifier/32/regs.sh
     /usr/lib/statifier/32/set_thread_area.sh
     /usr/lib/statifier/32/split.sh
     /usr/lib/statifier/32/statifier.gdb
%endif
%if %{has_elf_64}
# Elf64	own files
%dir /usr/lib/statifier/64
     /usr/lib/statifier/64/copy_ehdr
     /usr/lib/statifier/64/dl-var
     /usr/lib/statifier/64/elfinfo
     /usr/lib/statifier/64/elf_find_pattern
     /usr/lib/statifier/64/elf_stripped
     /usr/lib/statifier/64/find_dl_argc
     /usr/lib/statifier/64/find_dl_argv
     /usr/lib/statifier/64/find_dl_auxv
     /usr/lib/statifier/64/find_dl_platform
     /usr/lib/statifier/64/find_environ
     /usr/lib/statifier/64/loader_base_test
     /usr/lib/statifier/64/phdrs
     /usr/lib/statifier/64/regs
     /usr/lib/statifier/64/set_thread_area_addr
     /usr/lib/statifier/64/set_thread_area
     /usr/lib/statifier/64/strtoul
     /usr/lib/statifier/64/tls_test
     /usr/lib/statifier/64/properties.src
     /usr/lib/statifier/64/regs.awk
     /usr/lib/statifier/64/set_thread_area.gdb
# Elf64	links
     /usr/lib/statifier/64/statifier_lib.src
     /usr/lib/statifier/64/statifier_common.sh
     /usr/lib/statifier/64/statifier_loader.sh
     /usr/lib/statifier/64/statifier_dump.sh
     /usr/lib/statifier/64/statifier_create_starter.sh
     /usr/lib/statifier/64/statifier_create_exe.sh
     /usr/lib/statifier/64/dumps.sh
     /usr/lib/statifier/64/regs.sh
     /usr/lib/statifier/64/set_thread_area.sh
     /usr/lib/statifier/64/split.sh
     /usr/lib/statifier/64/statifier.gdb
%endif

%changelog
* Mon Jun 28 2004 <valery_reznic@users.sourceforge.net> 1.5.0-1
- gdb has a bad habbit sometimes (for example auto-solib-add = on and
  LD_PRELOAD is set - at least on amd64) output messages, which
  not new-line terminated. '(no debugging symbols found)...'
  So, statifier.gdb now output file separator to the gdb's log file
  which begin with newline.

* Thu Jun 24 2004 <valery_reznic@users.sourceforge.net> 1.5.0-1
- cleanup for Makefile in rpm directory
- statifier_common.sh now check if loader stripped.

* Wed Jun 23 2004 <valery_reznic@users.sourceforge.net> 1.5.0-1
- added elf_stripped program
- added code (both new executables and changed script) for
  dealing with stripped loaders (i.e loaders without symtab)

* Tue Jun 17 2004 <valery_reznic@users.sourceforge.net> 1.5.0-1
- statified executable include also non-allocated sections 
  from original exe. It don't affect application running,
  but make statified exe more friendly to gdb, objdump, readelf, etc.
  To achive it, starter segment format was changed: now it NOT include
  section headers. 
  phdrs.c now create two output files: starter_segment and sections.
  Sections file contains section headers and all non-allocated section
  from original exe.
  statifier_create_exe.sh was changed to deal with it.

* Wed Jun 16 2004 <valery_reznic@users.sourceforge.net> 1.5.0-1
- statifier_common.sh now use readelf instead of objdump to
  dump symbol. It help to detect present of thread local storage
  for stripped loader too.
  GetSymbol function from statifier_lib.src now printed out second field 
  instead of first, because objdump's and readelf's output formats are 
  bit different. 
- phdrs.c was changed to write output to the file instead of stdout.
  statifier_create_exe.sh was changed to reflect this change. 

* Tue Jun 15 2004 <valery_reznic@users.sourceforge.net> 1.4.0-1
- more documentation added

* Mon Jun 14 2004 <valery_reznic@users.sourceforge.net> 1.4.0-1
- added variable 'val_has_hit_msg' -  it used for eliminate 
  'Hit...' message on alpha and mips

* Sun Jun 13 2004 <valery_reznic@users.sourceforge.net> 1.4.0-1
- reworked command file for gdb. Now (almost all) merged into one
  statifier.gdb 
- cpus/*/set_thread_area.gdb changed to define command set_thread_area.
- statifier_dump.gdb now create var.gdb file

* Mon Jun  7 2004 <valery_reznic@users.sourceforge.net> 1.4.0-1
- added cpus/*/properties.src - support for different memory layout
- start.S and end.S now (I hope) processor independent:
  GET_DATA_ADDR macro was moved from start.S to cpus/*/processor.h 
  added define 'MY_JUMP' to cpus/*/processor.h.
  end.S now use 'MY_JUMP' 
- added copy_ehrd.c program
- added configs/alpha.config
- configs/* now have FLAGS_C_TO_ASM_{32,64} - to ensure calling convention

* Sun Jun  6 2004 <valery_reznic@users.sourceforge.net> 1.4.0-1
- phdrs reworked to support different memory layout
- statifier_create_exe.sh changed to support  different memory layout
- set_thread_area.sh was changed to be more robust
- set_thread_area_addr can be now compiled on alpha

* Tue Jun  1 2004 <valery_reznic@users.sourceforge.net> 1.4.0-1
- Fixed bug: in error message _dl_start_user not found was used
  (undefined) Interpreter instead of val_interpreter
- DataFlow.txt - fixed bug (Executable should be input for phdr,
   not for "create starter")

* Mon May 31 2004 <valery_reznic@users.sourceforge.net> 1.3.1-1
- processor.h was split to cpus/*/processor.h
- elf2at.make.sh was removed
- added documentation directory doc and documentation itself.
- added FAQ file

* Sun May  9 2004 <valery_reznic@users.sourceforge.net> 1.3.1-1
- cpus/x86_64/dl-var.S were converted to use dl-var.c and dl-var.inc
- added flag -mregparm=0 to be sure parameters passed via stack

* Wed May  5 2004 <valery_reznic@users.sourceforge.net> 1.3.1-1
- cpus/i386/dl-var.S were converted to use dl-var.c and dl-var.inc
- Makefile was adopted to this changes

* Tue May  4 2004 <valery_reznic@users.sourceforge.net> 1.3.0-1
- statifier_common.sh, CheckTls - grep was changed to awk

* Mon May  3 2004 <valery_reznic@users.sourceforge.net> 1.3.0-1
- added options --verbose and --keep-working-directory
- src/regs.sh now not use GNU awk extension.
- src/regs.awk was added.

* Sun May  2 2004 <valery_reznic@users.sourceforge.net> 1.3.0-1
- added options --versions and --help

* Thu Apr 29 2004 <valery_reznic@users.sourceforge.net> 1.3.0-1
- added file statifier_parser.src - parsing options.
- added Echo function to the statifier_lib.src
- updated man page

* Wed Apr 28 2004 <valery_reznic@users.sourceforge.net> 1.3.0-1
- changes in phdrs.c - relax check in order to work with
  linux >= 2.5 and gdb 6.1
- statifier_common.sh - more correct handling of BaseAddr and VirtAddr.
- map_reg_core.gdb was simplified - any way now i have absolute
  address of _dl_start_user and need no gdb's help to find it.
- get rid of gdb's (>= 6.0) message: rtld.c: No such file or directory
- statifier.sh if executable have no absolute path prepend ./ to it name
  (it prevent gdb from ocassionly pickup executable from another place)

* Sun Apr 25 2004 <valery_reznic@users.sourceforge.net> 1.2.1-1
- massive changes: statifier.sh split to lot of statifier_*.sh
- add statifier_lib.src
- add loader_base_test.c
- dl_ vars format was changed: now it's not offset from DL_BASE, 
  but absolute value. */dl-var.S were changed.
- readlink not used.  Makefile and rpm/files adjusted. 

* Thu Apr 22 2004 <valery_reznic@users.sourceforge.net> 1.2.1-1
- phdrs.c accept one more arguments - 'ignored_segments' 
- statifier.sh CreateExeFile now calculate and use IGNORED_SEGMENTS
- elfinfo.c program was added.

* Mon Apr 19 2004 <valery_reznic@users.sourceforge.net> 1.2.0-1
- examples added to the man

* Sun Apr 18 2004 <valery_reznic@users.sourceforge.net> 1.2.0-1
- now both elf32 and elf64 executables are supported.
- added support for amd64 (x86_64) processor

* Wed Apr  7 2004 <valery_reznic@users.sourceforge.net> 1.1.1-1
- reworked tls detection. added tls_test program
- add readlink program
- add dl-var
- set some loader variables as they should be
- fixed segfault in statified exe, which use dlsym function and dlsym
  can't find symbol. (May by it fix other segfaults too)

* Mon Mar 30 2004 <valery_reznic@users.sourceforge.net> 1.1.1-1
- fixed bug in the statifier.sh - added path to the set_thread_area_addr
- set_thread_area_addr program if it somehow miss syscall 
  'set_thread_area' exit with status 1, instead of status of
  inspected program.
- set_thread_area_addr.c - added function safe_fd - in case
  i miss 'set_thread_area' syscall

* Wed Mar 24 2004 <valery_reznic@users.sourceforge.net> 1.1.0-1
- a lot of change in order to support TLS (thread local storage)

* Mon Mar 16 2004 <valery_reznic@users.sourceforge.net> 1.1.0-1
- Fixed bug with Interpreter detection for (at least) LANG=es_ES@euro

* Mon Mar 15 2004 <valery_reznic@users.sourceforge.net> 1.0.0-1
- First public release
